=== debian/changelog ===
supercollider (1:3.5.2-1) unstable; urgency=low

  * Imported Upstream version 3.5.2
  * Add manpage for supernova
  * Use system mathjax via dh_linktree
  * Backport fix to vim plugin from upstream

 -- Dan Stowell <danstowell@users.sourceforge.net>  Sat, 16 Jun 2012 10:12:09 -0400

supercollider (1:3.5.1-2) UNRELEASED; urgency=low

  * install supercollider mode for gedit (thanks Tim Blechmann)

 -- Dan Stowell <danstowell@users.sourceforge.net>  Tue, 01 May 2012 10:11:34 +0100

supercollider (1:3.5.1-1) UNRELEASED; urgency=low

  [ Dan Stowell ]
  * Imported Upstream version 3.5.1
  * Import and adapt debian packaging info updates for SC 3.5 from tim blechmann
  * removing scons patches (no longer using scons)
  * Update paths & content of copyright file for SC 3.5

 -- Dan Stowell <danstowell@users.sourceforge.net>  Sat, 07 Apr 2012 14:01:57 +0100

supercollider (1:3.4.5-2) UNRELEASED; urgency=low

  * Drop dpkg-source local-options: Defaults since dpkg-source 1.16.1.
  * Update package relations:
    + Relax to build-depend unversioned on debhelper: needed version
      satisfied even in oldstable.
  * Bump debhelper compat level to 7.
  * Simplify install handling, as supported by debhelper compat level 7.
  * Stop setting bogus (or obsolete?) CDBS_NO_DOC_SYMLINKING.
  * Update copyright file:
    + Merge Files sections with same Licensing and (subsets of) same
      copyright holders.
    + Extend a Files section and drop another, to sync with new upstream
      source.
    + Sort authors by copyright year, and then alphabetically.
    + Add email of original author, from AUTHORS file.
    + Strip excess whitespace, and rewrap License sections at 72 chars.
    + Add Comment field to GNU License sections; shortened, duplicate
      texts dropped, using FSF web address (not postal address), and
      with license strings quoted.
  * Replace README.source:
    + Drop notes on no longer used quilt.
    + Add notes on git-buildpackage and CDBS.
  * Add myself as uploader.
  * Consistently newline-delimit package relations.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 08 Feb 2012 00:52:02 +0100
